// Generated by CoffeeScript 1.4.0
(function() {
  var coffee, escodegen, esprima, estools, expander, fs, jscoverageFormatting, path, tools, wrench, writeFile, _;

  fs = require('fs');

  path = require('path');

  _ = require('underscore');

  esprima = require('esprima');

  escodegen = require('escodegen');

  wrench = require('wrench');

  coffee = require('coffee-script');

  tools = require('./tools');

  estools = require('./estools');

  expander = require('./expander');

  jscoverageFormatting = require('./jscoverage-formatting');

  writeFile = (function() {
    var sourceMappings;
    sourceMappings = [
      function(x) {
        return x.replace(/&/g, '&amp;');
      }, function(x) {
        return x.replace(/</g, '&lt;');
      }, function(x) {
        return x.replace(/>/g, '&gt;');
      }, function(x) {
        return x.replace(/\\/g, '\\\\');
      }, function(x) {
        return x.replace(/"/g, '\\"');
      }, function(x) {
        return tools.strToNumericEntity(x);
      }, function(x) {
        return '"' + x + '"';
      }
    ];
    return function(originalCode, coveredCode, filename, trackedLines, coverageVar) {
      var originalSource, output;
      originalSource = originalCode.split(/\r?\n/g).map(function(line) {
        return sourceMappings.reduce((function(src, f) {
          return f(src);
        }), line);
      });
      if (_.last(originalSource) === '""') {
        originalSource = originalSource.slice(0, -1);
      }
      output = [];
      output.push("/* automatically generated by jscov - do not edit */");
      output.push("if (typeof " + coverageVar + " === 'undefined') " + coverageVar + " = {};");
      output.push("if (! " + coverageVar + "['" + filename + "']) {");
      output.push("  " + coverageVar + "['" + filename + "'] = [];");
      trackedLines.forEach(function(line) {
        return output.push("  " + coverageVar + "['" + filename + "'][" + line + "] = 0;");
      });
      output.push("}");
      output.push(coveredCode);
      output.push(("" + coverageVar + "['" + filename + "'].source = [") + originalSource.join(",") + "];");
      return output.join('\n');
    };
  })();

  exports.rewriteSource = function(code, filename) {
    var ast, coverageVar, injectList, outcode, trackedLines;
    injectList = {};
    coverageVar = '_$jscoverage';
    ast = esprima.parse(code, {
      loc: true
    });
    jscoverageFormatting.formatTree(ast);
    estools.addBeforeEveryStatement(ast, function(node) {
      injectList[node.loc.start.line] = 1;
      return estools.coverageNode(node, filename, coverageVar);
    });
    trackedLines = _.sortBy(Object.keys(injectList).map(function(x) {
      return parseInt(x, 10);
    }), _.identity);
    outcode = escodegen.generate(ast, {
      indent: "  "
    });
    return writeFile(code, outcode, filename, trackedLines, coverageVar);
  };

  exports.rewriteFolder = function(source, target, options, callback) {
    try {
      if (!(callback != null)) {
        callback = options;
        options = {};
      }
      wrench.rmdirSyncRecursive(target, true);
      wrench.readdirSyncRecursive(source).forEach(function(file) {
        var data, fullpath, outfile, output;
        fullpath = path.join(source, file);
        if (fs.lstatSync(fullpath).isDirectory()) {
          return;
        }
        data = fs.readFileSync(fullpath, 'utf8');
        if (file.match(/\.coffee$/)) {
          data = coffee.compile(data);
        } else if (!file.match(/\.js$/)) {
          data = null;
        }
        if (data !== null) {
          if (options.expand) {
            data = expander.expand(data);
          }
          output = exports.rewriteSource(data, file);
          outfile = path.join(target, file).replace(/\.coffee$/, '.js');
          wrench.mkdirSyncRecursive(path.dirname(outfile));
          return fs.writeFileSync(outfile, output, 'utf8');
        }
      });
    } catch (ex) {
      callback(ex);
      return;
    }
    return callback(null);
  };

  exports.cover = function(start, dir, file) {
    return path.join(start, process.env.JSCOV || dir, file);
  };

}).call(this);
