// Generated by CoffeeScript 1.4.0
(function() {
  var reservedWords;

  reservedWords = ['break', 'case', 'catch', 'continue', 'debugger', 'default', 'delete', 'do', 'else', 'false', 'finally', 'for', 'function', 'if', 'in', 'instanceof', 'new', 'null', 'return', 'switch', 'this', 'throw', 'true', 'try', 'typeof', 'var', 'void', 'while', 'with', 'abstract', 'boolean', 'byte', 'char', 'double', 'final', 'float', 'goto', 'implements', 'int', 'interface', 'long', 'native', 'package', 'private', 'protected', 'public', 'short', 'static', 'synchronized', 'throws', 'transient'];

  exports.evalBinaryExpression = (function() {
    var methods;
    methods = {
      '+': function(x, y) {
        return x + y;
      },
      '-': function(x, y) {
        return x - y;
      },
      '*': function(x, y) {
        return x * y;
      },
      '%': function(x, y) {
        return x % y;
      },
      '/': function(x, y) {
        return x / y;
      },
      '<<': function(x, y) {
        return x << y;
      },
      '>>': function(x, y) {
        return x >> y;
      },
      '>>>': function(x, y) {
        return x >>> y;
      }
    };
    return function(arg1, op, arg2) {
      var method;
      method = methods[op];
      if (!(method != null)) {
        throw "operator not supported";
      }
      return method(arg1, arg2);
    };
  })();

  exports.replaceProperties = function(obj, newProps) {
    var props;
    props = Object.getOwnPropertyNames(obj);
    props.forEach(function(prop) {
      return delete obj[prop];
    });
    return Object.getOwnPropertyNames(newProps).forEach(function(prop) {
      return obj[prop] = newProps[prop];
    });
  };

  exports.isValidIdentifier = function(name) {
    return (name != null ? name.toString().match(/^[_$a-zA-Z\xA0-\uFFFF][_$a-zA-Z0-9\xA0-\uFFFF]*$/) : void 0) && !exports.isReservedWord(name);
  };

  exports.isReservedWord = (function() {
    var reservedWordsHash;
    reservedWordsHash = reservedWords.reduce(function(acc, word) {
      acc[word] = 1;
      return acc;
    }, {});
    return function(name) {
      return !!reservedWordsHash.hasOwnProperty(name);
    };
  })();

  exports.strToNumericEntity = function(str) {
    var symbols, _i, _ref, _results;
    symbols = (function() {
      _results = [];
      for (var _i = 0, _ref = str.length; 0 <= _ref ? _i < _ref : _i > _ref; 0 <= _ref ? _i++ : _i--){ _results.push(_i); }
      return _results;
    }).apply(this).map(function(i) {
      var charCode;
      charCode = str.charCodeAt(i);
      if (charCode < 128) {
        return str[i];
      } else {
        return '&#' + charCode + ';';
      }
    });
    return symbols.join('');
  };

}).call(this);
